package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.rf.psychological.dao.model.AnswerEntity;
import com.rf.psychological.dao.model.DimensionEntity;
import com.rf.psychological.scale.dao.model.ScaleMarksEntity;

import java.text.DecimalFormat;
import java.util.*;

/**
 * @author lhl
 * @description:多维度交通心理控制源量表
 * @date 2021/11/01
 */
public class TLOCScale extends BaseScale {
    public TLOCScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }
    public JSONObject scaleCalculate() throws Exception{
        //总分
        double score = 0;
        Map<String, String> resultMap0 = new LinkedHashMap<>();
        List<Map<String,String>> resultMapList = new ArrayList<>();
        //获取答案列表
        List<AnswerEntity> answerEntities = (List<AnswerEntity>) resultJson.get("answerEntities");
        //获取评分规则列表
        List<ScaleMarksEntity> scaleMarksEntities = (List<ScaleMarksEntity>) resultJson.get("scaleMarksEntities");
        //获取维度信息列表
        List<DimensionEntity> dimensionEntities = (List<DimensionEntity>) resultJson.get("dimensionEntities");
        Map<String,Double> dimensionScoreMap = new HashMap<>();
        if (dimensionEntities.size() > 0){
            //计算每个维度得分

            double[] dimensionScore = new double[dimensionEntities.size()];
            for (int i = 0; i < jsonArray.size(); i++) {
                JSONObject jsonObject1 = jsonArray.getJSONObject(i);
                for (int y = 0; y < dimensionEntities.size(); y++) {
                    //for (DimensionEntity dimensionEntity:dimensionEntities){
                    DimensionEntity dimensionEntity = dimensionEntities.get(y);
                    String questionNos = dimensionEntity.getQuestionNo();
                    String[] questionNo = questionNos.split("；");
                    for (String question:questionNo){
                        if (question.equals(jsonObject1.getString("questionNo"))){
                            for (AnswerEntity answerEntity:answerEntities){
                                ///只用比较选项内容，进而判定该题目的分数值
                                if (answerEntity.getQuestionNo().equals(question) &&answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                                    dimensionScore[y] += Double.parseDouble(answerEntity.getScore());
                                }
                            }
                            break;
                        }
                    }
                }
               /* //计算总分
                for (AnswerEntity answerEntity:answerEntities){
                    if (answerEntity.getQuestionNo().equals(String.valueOf(i+1))){
                        if (answerEntity.getName().equals(jsonObject1.getString("checkItems"))){
                            score += Integer.valueOf(answerEntity.getScore());
                        }
                    }
                }*/
            }

           /* resultMap0.put("GDMS总分", String.valueOf(score));
            resultJson.put("GDMS总分", String.valueOf(score));*/
            //计算每个维度的平均分
            DecimalFormat df = new DecimalFormat("######0.00");
            double[] Mdscore = new double[dimensionScore.length];
            for (int i = 0; i < dimensionScore.length; i++) {
                if(i==1||i==2){
                    Mdscore[i]= Double.parseDouble(df.format(dimensionScore[i]/4.0));
                }else if(i==0) {
                    Mdscore[i]= Double.parseDouble(df.format(dimensionScore[i]/5.0));
                }else if(i==3) {
                    Mdscore[i]= Double.parseDouble(df.format(dimensionScore[i]/3.0));
                }

            }

            resultMap0.put("其他驾驶员维度均分", String.valueOf(Mdscore[0]));
            resultMap0.put("自我维度均分", String.valueOf(Mdscore[1]));
            resultMap0.put("车辆和环境维度均分", String.valueOf(Mdscore[2]));
            resultMap0.put("命运维度均分", String.valueOf(Mdscore[3]));
            resultMap0.put("内控源均分", String.valueOf(Mdscore[1]));
            double v = Double.parseDouble(df.format((Mdscore[3] + Mdscore[2] + Mdscore[0]) / 3));
            resultMap0.put("外控源均分", String.valueOf(v));

            resultJson.put("其他驾驶员维度均分", String.valueOf(Mdscore[0]));
            resultJson.put("自我维度均分", String.valueOf(Mdscore[1]));
            resultJson.put("车辆和环境维度均分", String.valueOf(Mdscore[2]));
            resultJson.put("命运维度均分", String.valueOf(Mdscore[3]));
            resultJson.put("内控源均分", String.valueOf(Mdscore[1]));
            resultJson.put("外控源均分", String.valueOf(v));


            dimensionScoreMap.put("2c91f37d7bec0878017c4137fd233ac9", Mdscore[0]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4137fd4b3aca", Mdscore[1]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4137fd733acb", Mdscore[2]);
            dimensionScoreMap.put("2c91f37d7bec0878017c4137fd9b3acc", Mdscore[3]);

            resultJson.put("dimensionScoreMap",dimensionScoreMap);
            resultMapList.add(resultMap0);
        }

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("scaleName",resultJson.getString("scaleName"));
        returnJson.put("resultJson",resultJson);

        return returnJson;

    }
}
